Index: XIOS3/branches/xios-3.0-beta/arch/arch-X64_SPIRIT.env
===================================================================
--- XIOS3/branches/xios-3.0-beta/arch/arch-X64_SPIRIT.env	(revision 2552)
+++ 	(revision )
@@ -1,16 +1,0 @@
-module purge
-module load intel/2021.4.0
-module load openmpi/4.1.4-hybrid
-module load hdf5/1.10.7-hybrid
-module load netcdf-c/4.7.4-hybrid
-
-# IRENE module load flavor/buildcompiler/intel/20
-# IRENE module load mpi/openmpi/4.1.4 
-# IRENE 
-# IRENE module load flavor/hdf5/parallel
-# IRENE module load hdf5/1.12.2
-# IRENE module load netcdf-fortran/4.5.3
-# IRENE module load gnu/8.3.0
-# IRENE 
-# IRENE module load totalview
-# IRENE module load perl/5.32.1
Index: XIOS3/branches/xios-3.0-beta/arch/arch-X64_SPIRIT.fcm
===================================================================
--- XIOS3/branches/xios-3.0-beta/arch/arch-X64_SPIRIT.fcm	(revision 2552)
+++ 	(revision )
@@ -1,26 +1,0 @@
-################################################################################
-###################                Projet XIOS               ###################
-################################################################################
-
-%CCOMPILER      mpicc
-%FCOMPILER      mpif90
-%LINKER         mpif90  -nofor-main
-
-%BASE_CFLAGS    -std=c++11 -diag-disable 1125 -diag-disable 279 -D__XIOS_EXCEPTION
-%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
-#%DEV_CFLAGS     -g -traceback
-%DEV_CFLAGS     -g 
-%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
-
-%BASE_FFLAGS    -D__NONE__ 
-%PROD_FFLAGS    -O3
-#%DEV_FFLAGS     -g -traceback
-%DEV_FFLAGS     -g 
-%DEBUG_FFLAGS   -g -traceback
-
-%BASE_INC       -D__NONE__
-%BASE_LD        -lstdc++
-
-%CPP            mpicc -EP
-%FPP            cpp -P
-%MAKE           make
Index: XIOS3/branches/xios-3.0-beta/arch/arch-X64_SPIRIT.path
===================================================================
--- XIOS3/branches/xios-3.0-beta/arch/arch-X64_SPIRIT.path	(revision 2552)
+++ 	(revision )
@@ -1,28 +1,0 @@
-NETCDF_INCDIR="-I $NETCDF_C_ROOT/include"
-NETCDF_LIBDIR="-L $NETCDF_C_ROOT/lib"
-NETCDF_LIB="-lnetcdf"
-
-MPI_INCDIR=""
-MPI_LIBDIR=""
-MPI_LIB=""
-
-HDF5_INCDIR="-I$HDF5_ROOT/include"
-HDF5_LIBDIR="-L$HDF5_ROOT/lib"
-HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
-
-BOOST_INCDIR="-I $BOOST_INCDIR"
-BOOST_LIBDIR="-L $BOOST_LIBDIR"
-BOOST_LIB=""
-
-BLITZ_INCDIR="-I $BLITZ_INCDIR"
-BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
-BLITZ_LIB=""
-
-OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
-OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
-
-
-#only for MEMTRACK debuging : developper only
-ADDR2LINE_LIBDIR="-L${WORKDIR}/ADDR2LINE_LIB"
-ADDR2LINE_LIB="-laddr2line"
Index: XIOS3/branches/xios-3.0-beta/arch/arch-ifort_LSCE.env
===================================================================
--- XIOS3/branches/xios-3.0-beta/arch/arch-ifort_LSCE.env	(revision 2553)
+++ XIOS3/branches/xios-3.0-beta/arch/arch-ifort_LSCE.env	(revision 2553)
@@ -0,0 +1,9 @@
+module purge
+#source /usr/share/Modules/init/bash
+module load gcc/8.3.0
+module load openmpi/2.1.5
+export OMPI_CC=icc
+export OMPI_FC=ifort
+module load hdf5/1.10.5
+module load netcdf/4.7
+
Index: XIOS3/branches/xios-3.0-beta/arch/arch-ifort_LSCE.fcm
===================================================================
--- XIOS3/branches/xios-3.0-beta/arch/arch-ifort_LSCE.fcm	(revision 2552)
+++ XIOS3/branches/xios-3.0-beta/arch/arch-ifort_LSCE.fcm	(revision 2553)
@@ -1,14 +1,20 @@
-%CCOMPILER           mpicc
-%FCOMPILER           mpif90
-%LINKER              mpif90 -nofor-main
+################################################################################
+###################                Projet XIOS               ###################
+################################################################################
 
-%BASE_CFLAGS
+%CCOMPILER      mpicc
+%FCOMPILER      mpif90
+%LINKER         mpif90  -nofor-main
+
+%BASE_CFLAGS    -std=c++11 -diag-disable 1125 -diag-disable 279 -D__XIOS_EXCEPTION
 %PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
-%DEV_CFLAGS     -g
-%DEBUG_CFLAGS   -DBZ_DEBUG -g -fno-inline
+#%DEV_CFLAGS     -g -traceback
+%DEV_CFLAGS     -g 
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
 
-%BASE_FFLAGS    -D__NONE__
+%BASE_FFLAGS    -D__NONE__ 
 %PROD_FFLAGS    -O3
-%DEV_FFLAGS     -g -O2 -traceback
+#%DEV_FFLAGS     -g -traceback
+%DEV_FFLAGS     -g 
 %DEBUG_FFLAGS   -g -traceback
 
@@ -18,3 +24,3 @@
 %CPP            mpicc -EP
 %FPP            cpp -P
-%MAKE           gmake
+%MAKE           make
Index: XIOS3/branches/xios-3.0-beta/arch/arch-ifort_LSCE.path
===================================================================
--- XIOS3/branches/xios-3.0-beta/arch/arch-ifort_LSCE.path	(revision 2552)
+++ XIOS3/branches/xios-3.0-beta/arch/arch-ifort_LSCE.path	(revision 2553)
@@ -1,6 +1,28 @@
-NETCDF_INCDIR="-I /usr/local/install/netcdf-4.3.2p/include"
-NETCDF_LIBDIR="-L/usr/local/install/netcdf-4.3.2p/lib"
-NETCDF_LIB="-lnetcdf -lnetcdff"
-HDF5_INCDIR="-I /usr/local/install/hdf5-1.8.9p/include"
-HDF5_LIBDIR="-L/usr/local/install/hdf5-1.8.9p/lib"
-HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
+NETCDF_INCDIR="-I $NETCDF4_DIR/include"
+NETCDF_LIBDIR="-L $NETCDF4_DIR/lib"
+NETCDF_LIB="-lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I/usr/local/install/hdf5-1.10.5/include"
+HDF5_LIBDIR="-L/usr/local/install/hdf5-1.10.5/lib"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
+
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
+
+
+#only for MEMTRACK debuging : developper only
+ADDR2LINE_LIBDIR="-L${WORKDIR}/ADDR2LINE_LIB"
+ADDR2LINE_LIB="-laddr2line"
Index: XIOS3/branches/xios-3.0-beta/arch/arch-ifort_MESOIPSL.env
===================================================================
--- XIOS3/branches/xios-3.0-beta/arch/arch-ifort_MESOIPSL.env	(revision 2553)
+++ XIOS3/branches/xios-3.0-beta/arch/arch-ifort_MESOIPSL.env	(revision 2553)
@@ -0,0 +1,5 @@
+module purge
+module load intel/2021.4.0
+module load openmpi/4.1.4-hybrid
+module load hdf5/1.10.7-hybrid
+module load netcdf-c/4.7.4-hybrid
Index: XIOS3/branches/xios-3.0-beta/arch/arch-ifort_MESOIPSL.fcm
===================================================================
--- XIOS3/branches/xios-3.0-beta/arch/arch-ifort_MESOIPSL.fcm	(revision 2553)
+++ XIOS3/branches/xios-3.0-beta/arch/arch-ifort_MESOIPSL.fcm	(revision 2553)
@@ -0,0 +1,26 @@
+################################################################################
+###################                Projet XIOS               ###################
+################################################################################
+
+%CCOMPILER      mpicc
+%FCOMPILER      mpif90
+%LINKER         mpif90  -nofor-main
+
+%BASE_CFLAGS    -std=c++11 -diag-disable 1125 -diag-disable 279 -D__XIOS_EXCEPTION
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+#%DEV_CFLAGS     -g -traceback
+%DEV_CFLAGS     -g 
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
+
+%BASE_FFLAGS    -D__NONE__ 
+%PROD_FFLAGS    -O3
+#%DEV_FFLAGS     -g -traceback
+%DEV_FFLAGS     -g 
+%DEBUG_FFLAGS   -g -traceback
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++
+
+%CPP            mpicc -EP
+%FPP            cpp -P
+%MAKE           make
Index: XIOS3/branches/xios-3.0-beta/arch/arch-ifort_MESOIPSL.path
===================================================================
--- XIOS3/branches/xios-3.0-beta/arch/arch-ifort_MESOIPSL.path	(revision 2553)
+++ XIOS3/branches/xios-3.0-beta/arch/arch-ifort_MESOIPSL.path	(revision 2553)
@@ -0,0 +1,28 @@
+NETCDF_INCDIR="-I $NETCDF_C_ROOT/include"
+NETCDF_LIBDIR="-L $NETCDF_C_ROOT/lib"
+NETCDF_LIB="-lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I$HDF5_ROOT/include"
+HDF5_LIBDIR="-L$HDF5_ROOT/lib"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
+
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
+
+
+#only for MEMTRACK debuging : developper only
+ADDR2LINE_LIBDIR="-L${WORKDIR}/ADDR2LINE_LIB"
+ADDR2LINE_LIB="-laddr2line"