Index: XIOS3/trunk/src/transport/legacy_context_client.cpp
===================================================================
--- XIOS3/trunk/src/transport/legacy_context_client.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/legacy_context_client.cpp	(revision 2589)
@@ -31,6 +31,6 @@
     {
       pureOneSided=CXios::getin<bool>("pure_one_sided",false); // pure one sided communication (for test)
-      MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
-      MPI_Comm_split(intraComm_,clientRank,clientRank, &commSelf_) ; // for windows
+      xios::MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
+      xios::MPI_Comm_split(intraComm_,clientRank,clientRank, &commSelf_) ; // for windows
       eventScheduler_ = parent->getEventScheduler() ;  
       timeLine = 1;
@@ -219,7 +219,7 @@
           MPI_Comm interComm ;
           int tag = 0 ;
-          MPI_Intercomm_create(commSelf_, 0, interCommMerged_, clientSize+rank, tag, &interComm) ;
-          MPI_Intercomm_merge(interComm, false, &winComm_[rank]) ;
-          MPI_Comm_free(&interComm) ;
+          xios::MPI_Intercomm_create(commSelf_, 0, interCommMerged_, clientSize+rank, tag, &interComm) ;
+          xios::MPI_Intercomm_merge(interComm, false, &winComm_[rank]) ;
+          xios::MPI_Comm_free(&interComm) ;
                 
           buffer->attachWindows(winComm_[rank]) ;
@@ -242,7 +242,7 @@
             MPI_Comm interComm ;
             int tag = 0 ;
-            MPI_Intercomm_create(commSelf_, 0, interCommMerged_, clientSize+rank, tag, &interComm) ;
-            MPI_Intercomm_merge(interComm, false, &winComm_[rank]) ;
-            MPI_Comm_free(&interComm) ;
+            xios::MPI_Intercomm_create(commSelf_, 0, interCommMerged_, clientSize+rank, tag, &interComm) ;
+            xios::MPI_Intercomm_merge(interComm, false, &winComm_[rank]) ;
+            xios::MPI_Comm_free(&interComm) ;
               
             buffer->attachWindows(winComm_[rank]) ;
Index: XIOS3/trunk/src/transport/legacy_context_server.cpp
===================================================================
--- XIOS3/trunk/src/transport/legacy_context_server.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/legacy_context_server.cpp	(revision 2589)
@@ -36,5 +36,5 @@
   {
  
-    MPI_Comm_dup(intraComm, &processEventBarrier_) ;
+    xios::MPI_Comm_dup(intraComm, &processEventBarrier_) ;
  
 
@@ -43,6 +43,6 @@
     finished=false;
 
-    MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
-    MPI_Comm_split(intraComm_, intraCommRank, intraCommRank, &commSelf_) ; // for windows
+    xios::MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
+    xios::MPI_Comm_split(intraComm_, intraCommRank, intraCommRank, &commSelf_) ; // for windows
     
     itLastTimeLine=lastTimeLine.begin() ;
@@ -122,7 +122,7 @@
       MPI_Comm interComm ;
       int tag = 0 ;
-      MPI_Intercomm_create(commSelf_, 0, interCommMerged_, rank, tag , &interComm) ;
-      MPI_Intercomm_merge(interComm, true, &winComm_[rank]) ;
-      MPI_Comm_free(&interComm) ;
+      xios::MPI_Intercomm_create(commSelf_, 0, interCommMerged_, rank, tag , &interComm) ;
+      xios::MPI_Intercomm_merge(interComm, true, &winComm_[rank]) ;
+      xios::MPI_Comm_free(&interComm) ;
       windows_[rank].resize(2) ;
       //MPI_Win_create_dynamic(MPI_INFO_NULL, winComm_[rank], &windows_[rank][0]);
Index: XIOS3/trunk/src/transport/one_sided_client_buffer.cpp
===================================================================
--- XIOS3/trunk/src/transport/one_sided_client_buffer.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/one_sided_client_buffer.cpp	(revision 2589)
@@ -22,11 +22,11 @@
     CTimer::get("create Windows").resume() ;
     MPI_Comm interComm ;
-    MPI_Intercomm_create(commSelf, 0, interCommMerged, intraServerRank, 0, &interComm) ;
-    MPI_Intercomm_merge(interComm, false, &winComm_) ;
+    xios::MPI_Intercomm_create(commSelf, 0, interCommMerged, intraServerRank, 0, &interComm) ;
+    xios::MPI_Intercomm_merge(interComm, false, &winComm_) ;
     int rank ;
     MPI_Comm_rank(winComm_,&rank) ;
     info(logProtocol)<<"Windows rank="<<rank<<endl ;
     CXios::getMpiGarbageCollector().registerCommunicator(winComm_) ;
-    MPI_Comm_free(&interComm) ;
+    xios::MPI_Comm_free(&interComm) ;
     
     maxWindows_=MAX_WINDOWS ;    
Index: XIOS3/trunk/src/transport/one_sided_context_client.cpp
===================================================================
--- XIOS3/trunk/src/transport/one_sided_context_client.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/one_sided_context_client.cpp	(revision 2589)
@@ -31,7 +31,7 @@
       pureOneSided=CXios::getin<bool>("pure_one_sided",false); // pure one sided communication (for test)
 
-      MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
-      
-      MPI_Comm_split(intraComm_,clientRank,clientRank, &commSelf_) ; // for windows
+      xios::MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
+      
+      xios::MPI_Comm_split(intraComm_,clientRank,clientRank, &commSelf_) ; // for windows
       eventScheduler_ = parent->getEventScheduler() ;  
       timeLine = 1;
Index: XIOS3/trunk/src/transport/one_sided_context_server.cpp
===================================================================
--- XIOS3/trunk/src/transport/one_sided_context_server.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/one_sided_context_server.cpp	(revision 2589)
@@ -36,5 +36,5 @@
   {
    
-    MPI_Comm_dup(intraComm, &processEventBarrier_) ;
+    xios::MPI_Comm_dup(intraComm, &processEventBarrier_) ;
  
     currentTimeLine=1;
@@ -42,6 +42,6 @@
     finished=false;
 
-    MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
-    MPI_Comm_split(intraComm_, intraCommRank, intraCommRank, &commSelf_) ; // for windows
+    xios::MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
+    xios::MPI_Comm_split(intraComm_, intraCommRank, intraCommRank, &commSelf_) ; // for windows
     
     itLastTimeLine=lastTimeLine.begin() ;
@@ -237,5 +237,5 @@
     //    MPI_Win_free(&windows_[rank][0]);
     //    MPI_Win_free(&windows_[rank][1]);
-    //    MPI_Comm_free(&winComm_[rank]) ;
+    //    xios::MPI_Comm_free(&winComm_[rank]) ;
     //  }
   }
Index: XIOS3/trunk/src/transport/one_sided_server_buffer.cpp
===================================================================
--- XIOS3/trunk/src/transport/one_sided_server_buffer.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/one_sided_server_buffer.cpp	(revision 2589)
@@ -25,8 +25,8 @@
     CTimer::get("create Windows").resume() ;
     MPI_Comm interComm ;
-    MPI_Intercomm_create(commSelf, 0, interCommMerged, clientRank_, 0 , &interComm) ;
-    MPI_Intercomm_merge(interComm, true, &winComm_) ;
+    xios::MPI_Intercomm_create(commSelf, 0, interCommMerged, clientRank_, 0 , &interComm) ;
+    xios::MPI_Intercomm_merge(interComm, true, &winComm_) ;
     CXios::getMpiGarbageCollector().registerCommunicator(winComm_) ;
-    MPI_Comm_free(&interComm) ;
+    xios::MPI_Comm_free(&interComm) ;
     
     maxWindows_=MAX_WINDOWS ;
Index: XIOS3/trunk/src/transport/p2p_client_buffer.cpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_client_buffer.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/p2p_client_buffer.cpp	(revision 2589)
@@ -24,11 +24,11 @@
     CTimer::get("create Windows").resume() ;
     //MPI_Comm interComm ;
-    //MPI_Intercomm_create(commSelf, 0, interCommMerged, intraServerRank, 0, &interComm) ;
-    //MPI_Intercomm_merge(interComm, false, &winComm_) ;
+    //xios::MPI_Intercomm_create(commSelf, 0, interCommMerged, intraServerRank, 0, &interComm) ;
+    //xios::MPI_Intercomm_merge(interComm, false, &winComm_) ;
     //int rank ;
     //MPI_Comm_rank(winComm_,&rank) ;
     //info(logProtocol)<<"Windows rank="<<rank<<endl ;
     //CXios::getMpiGarbageCollector().registerCommunicator(winComm_) ;
-    //MPI_Comm_free(&interComm) ;
+    //xios::MPI_Comm_free(&interComm) ;
     
     maxWindows_=MAX_WINDOWS ;    
Index: XIOS3/trunk/src/transport/p2p_context_client.cpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_context_client.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/p2p_context_client.cpp	(revision 2589)
@@ -31,8 +31,8 @@
       pureOneSided=CXios::getin<bool>("pure_one_sided",false); // pure one sided communication (for test)
 
-      MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
+      xios::MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
       CXios::getMpiGarbageCollector().registerCommunicator(interCommMerged_) ;
       
-      MPI_Comm_split(intraComm_,clientRank,clientRank, &commSelf_) ; // for windows
+      xios::MPI_Comm_split(intraComm_,clientRank,clientRank, &commSelf_) ; // for windows
       CXios::getMpiGarbageCollector().registerCommunicator(commSelf_) ;
       eventScheduler_ = parent->getEventScheduler() ;  
Index: XIOS3/trunk/src/transport/p2p_context_server.cpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_context_server.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/p2p_context_server.cpp	(revision 2589)
@@ -36,5 +36,5 @@
   {
    
-    MPI_Comm_dup(intraComm, &processEventBarrier_) ;
+    xios::MPI_Comm_dup(intraComm, &processEventBarrier_) ;
     CXios::getMpiGarbageCollector().registerCommunicator(processEventBarrier_) ;
     
@@ -43,7 +43,7 @@
     finished=false;
 
-    MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
+    xios::MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
     CXios::getMpiGarbageCollector().registerCommunicator(interCommMerged_) ;
-    MPI_Comm_split(intraComm_, intraCommRank, intraCommRank, &commSelf_) ; // for windows
+    xios::MPI_Comm_split(intraComm_, intraCommRank, intraCommRank, &commSelf_) ; // for windows
     CXios::getMpiGarbageCollector().registerCommunicator(commSelf_) ;
     
@@ -244,5 +244,5 @@
     //    MPI_Win_free(&windows_[rank][0]);
     //    MPI_Win_free(&windows_[rank][1]);
-    //    MPI_Comm_free(&winComm_[rank]) ;
+    //    xios::MPI_Comm_free(&winComm_[rank]) ;
     //  }
   }
Index: XIOS3/trunk/src/transport/p2p_server_buffer.cpp
===================================================================
--- XIOS3/trunk/src/transport/p2p_server_buffer.cpp	(revision 2587)
+++ XIOS3/trunk/src/transport/p2p_server_buffer.cpp	(revision 2589)
@@ -25,8 +25,8 @@
     CTimer::get("create Windows").resume() ;
     //MPI_Comm interComm ;
-    //MPI_Intercomm_create(commSelf, 0, interCommMerged, clientRank_, 0 , &interComm) ;
-    //MPI_Intercomm_merge(interComm, true, &winComm_) ;
+    //xios::MPI_Intercomm_create(commSelf, 0, interCommMerged, clientRank_, 0 , &interComm) ;
+    //xios::MPI_Intercomm_merge(interComm, true, &winComm_) ;
     //CXios::getMpiGarbageCollector().registerCommunicator(winComm_) ;
-    //MPI_Comm_free(&interComm) ;
+    //xios::MPI_Comm_free(&interComm) ;
     
     //maxWindows_=MAX_WINDOWS ;